SystemOrganization addCategory: #ConfigurationOfCreativeCommonsLive!

Object subclass: #ConfigurationOfCreativeCommonsLive
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfCreativeCommonsLive'!

!ConfigurationOfCreativeCommonsLive class methodsFor: 'development support' stamp: 'SeanDeNigris 3/24/2015 11:39'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfCreativeCommonsLive class methodsFor: 'private' stamp: 'SeanDeNigris 3/24/2015 11:39'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfCreativeCommonsLive class methodsFor: 'private' stamp: 'SeanDeNigris 3/24/2015 11:39'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfCreativeCommonsLive class methodsFor: 'private' stamp: 'SeanDeNigris 3/24/2015 11:39'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfCreativeCommonsLive class methodsFor: 'metacello tool support' stamp: 'SeanDeNigris 3/24/2015 11:39'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfCreativeCommonsLive class methodsFor: 'loading' stamp: 'SeanDeNigris 3/24/2015 11:39'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfCreativeCommonsLive class methodsFor: 'loading' stamp: 'SeanDeNigris 3/24/2015 11:39'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfCreativeCommonsLive class methodsFor: 'loading' stamp: 'SeanDeNigris 3/24/2015 11:39'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfCreativeCommonsLive class methodsFor: 'accessing' stamp: 'SeanDeNigris 3/24/2015 11:39'!
project

	^self new project! !

!ConfigurationOfCreativeCommonsLive class methodsFor: 'development support' stamp: 'SeanDeNigris 3/24/2015 11:39'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfCreativeCommonsLive methodsFor: 'baselines' stamp: 'SeanDeNigris 7/8/2015 14:42'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://smalltalkhub.com/mc/SeanDeNigris/CreativeCommonsLive/main/'.
		spec project: 'BabyPhexample' with: [
				spec
					className: #ConfigurationOfBabyPhexample;
					versionString: #'stable';
					repository: 'http://smalltalkhub.com/mc/SeanDeNigris/SeansMetaRepo/main/' ].
		spec package: #CreativeCommonsLive with: [
				spec requires: #('BabyPhexample' ). ]. ].
! !

!ConfigurationOfCreativeCommonsLive methodsFor: 'accessing' stamp: 'SeanDeNigris 3/24/2015 11:39'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfCreativeCommonsLive methodsFor: 'symbolic versions' stamp: 'SeanDeNigris 7/8/2015 13:39'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1-baseline'.
! !

!ConfigurationOfCreativeCommonsLive methodsFor: 'accessing' stamp: 'SeanDeNigris 3/24/2015 11:39'!
project

	^ project ifNil: [ 
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		(Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfCreativeCommonsLive methodsFor: 'symbolic versions' stamp: 'SeanDeNigris 7/8/2015 13:39'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfCreativeCommonsLive methodsFor: 'versions' stamp: 'SeanDeNigris 7/8/2015 14:43'!
version10: spec
	<version: '1.0' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'stable'.
		spec description: 'Plain text, and HTML attributions following the "ideal attribution" reference at https://wiki.creativecommons.org/wiki/Best_practices_for_attribution'.
		spec author: 'SeanDeNigris'.
		spec timestamp: '7/8/2015 13:39'.
		spec project: 'BabyPhexample' with: '1.0.1'.
		spec package: #CreativeCommonsLive with: 'CreativeCommonsLive-SeanDeNigris.1'. ].
! !
